Attribute VB_Name = "modCrypt"
Option Explicit
    
Public Declare Sub RtlMoveMemory Lib "kernel32" (ByVal hpvDest As Any, ByVal hpvSource As Any, ByVal nBytes As Long)


Public Function lBSL(ByRef lInput As Long, ByRef bShiftBits As Byte) As Long
    
    On Error GoTo ErrorHandle
    
    lBSL = (lInput And (2 ^ (31 - bShiftBits) - 1)) * 2 ^ bShiftBits
    If (lInput And 2 ^ (31 - bShiftBits)) = 2 ^ (31 - bShiftBits) Then lBSL = (lBSL Or &H80000000)
Exit Function

ErrorHandle:
End Function


Public Function lBSR(ByRef lInput As Long, ByRef bShiftBits As Byte) As Long
    
    On Error GoTo ErrorHandle

    If bShiftBits = 31 Then
        If lInput < 0 Then lBSR = &HFFFFFFFF Else lBSR = 0
    Else
        lBSR = (lInput And Not (2 ^ bShiftBits - 1)) \ 2 ^ bShiftBits
    End If
Exit Function

ErrorHandle:
End Function


Public Function lBSRU(ByRef lInput As Long, ByRef bShiftBits As Byte) As Long
    
    On Error GoTo ErrorHandle
    
    If bShiftBits = 31 Then
        If lInput < 0 Then lBSRU = 1 Else lBSRU = 0
    Else
        lBSRU = (((lInput And Not (2 ^ bShiftBits - 1)) \ 2 ^ bShiftBits) And Not (&H80000000 + (2 ^ bShiftBits - 2) * 2 ^ (31 - bShiftBits)))
    End If
Exit Function

ErrorHandle:
End Function


Public Function lBSRRot(ByRef lInput As Long, ByRef bShiftBits As Byte) As Long
    Dim t As Long
    
    On Error GoTo ErrorHandle
    
    If bShiftBits = 31 Then
        If lInput < 0 Then t = 1
    Else
        t = (((lInput And Not (2 ^ bShiftBits - 1)) \ 2 ^ bShiftBits) And Not (&H80000000 + (2 ^ bShiftBits - 2) * 2 ^ (31 - bShiftBits)))
    End If
    lBSRRot = (lInput And (2 ^ (bShiftBits - 1) - 1)) * 2 ^ (32 - bShiftBits)
    If (lInput And 2 ^ (bShiftBits - 1)) = 2 ^ (bShiftBits - 1) Then lBSRRot = (lBSRRot Or &H80000000)
    lBSRRot = lBSRRot Or t
Exit Function

ErrorHandle:
End Function
